/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.main.ConfigManager
 *  fire.pb.npc.SGatherConfig
 *  fire.pb.scene.Scene
 *  fire.pb.scene.manager.GatherManager
 *  fire.pb.scene.manager.RoleManager
 *  fire.pb.scene.sPos.Position
 */
package fire.pb.scene.movable;

import fire.pb.main.ConfigManager;
import fire.pb.npc.SGatherConfig;
import fire.pb.scene.Scene;
import fire.pb.scene.manager.GatherManager;
import fire.pb.scene.manager.RoleManager;
import fire.pb.scene.movable.NPC;
import fire.pb.scene.movable.Role;
import fire.pb.scene.sPos.Position;
import java.util.Calendar;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class GatherNpc
extends NPC {
    private volatile int lefttime = -1;
    private volatile Map<Long, Long> gatherplayers = new ConcurrentHashMap<Long, Long>();
    private boolean canRemove = true;
    private final int cooldown;

    GatherNpc(long npckey, int npcid, String name, Scene scene, Position pos, int dir) {
        super(npckey, npcid, name, scene, pos, dir);
        SGatherConfig conf = (SGatherConfig)ConfigManager.getInstance().getConf(SGatherConfig.class).get(this.getNpcID());
        if (conf != null) {
            if (conf.可采集次数 != 0) {
                this.lefttime = conf.可采集次数;
            }
            this.canRemove = conf.是否消失 == 1;
            this.cooldown = conf.coolingtime;
        } else {
            this.cooldown = 0;
        }
    }

    public synchronized void onGatherEnd(long roleid, int result) {
        if (this.cooldown != 0) {
            Calendar now = Calendar.getInstance();
            now.add(13, this.cooldown);
            this.gatherplayers.put(roleid, now.getTimeInMillis());
        }
        if (this.lefttime != -1) {
            --this.lefttime;
            if (this.lefttime == 0 && this.canRemove) {
                GatherManager.getInstance().removeGathernpc(this.getScene().getMapID(), this.getUniqueID());
                return;
            }
        }
    }

    public boolean inCooldown(long roleid) {
        Long cangathertime = this.gatherplayers.get(roleid);
        return cangathertime != null && Calendar.getInstance().getTimeInMillis() < cangathertime;
    }

    public boolean canGather(long roleid) {
        if (this.inCooldown(roleid)) {
            return false;
        }
        Role player = RoleManager.getInstance().getRoleByID(roleid);
        if (player == null) {
            return true;
        }
        return player.checkDistance(this, 400);
    }

    @Override
    public void setScene(Scene scene) {
        super.setScene(scene);
        ConcurrentHashMap<Long, GatherNpc> sceneGathers = GatherManager.getInstance().getGathersByMapID(scene.getMapID());
        if (sceneGathers == null) {
            sceneGathers = new ConcurrentHashMap<Long, GatherNpc>();
            GatherManager.getInstance().getGatherMap().put(scene.getMapID(), sceneGathers);
        }
        sceneGathers.put(this.getUniqueID(), this);
    }
}

